﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using HaloMap;

namespace Gravemind
{
    public partial class Settings : Form
    {
        public Settings()
        {
            InitializeComponent();
        }

        private void Settings_Load(object sender, EventArgs e)
        {
            StreamReader sr;
            try
            {
                sr = new StreamReader(new FileStream(Application.StartupPath + "\\Settings\\Settings.cfg", FileMode.Open, FileAccess.Read, FileShare.Read));
                txtShared.Text = sr.ReadLine();
                txtMainMenu.Text = sr.ReadLine();
                txtSingleplayershared.Text = sr.ReadLine();
                checkBox1.Checked = bool.Parse(sr.ReadLine());
                checkBox2.Checked = bool.Parse(sr.ReadLine());
                sr.Close();
            }
            catch (Exception) { }

            try
            {
                sr = new StreamReader(Application.StartupPath + "\\Settings\\Collision.cfg");
                btnSphereColor.BackColor = Color.FromArgb(Convert.ToInt32(sr.ReadLine()));
                btnWorldColor.BackColor = Color.FromArgb(Convert.ToInt32(sr.ReadLine()));
                comboBox1.SelectedIndex = Convert.ToInt32(sr.ReadLine());
                sr.Close();
            }
            catch (Exception) { }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            StreamWriter sw = new StreamWriter(new FileStream(Application.StartupPath + "\\Settings\\Settings.cfg", FileMode.OpenOrCreate, FileAccess.Write, FileShare.Write));
            sw.WriteLine(txtShared.Text);
            sw.WriteLine(txtMainMenu.Text);
            sw.WriteLine(txtSingleplayershared.Text);
            sw.WriteLine(checkBox1.Checked.ToString());
            sw.WriteLine(checkBox2.Checked.ToString());
            sw.Close();

            sw = new StreamWriter(Application.StartupPath + "\\Settings\\Collision.cfg");
            sw.WriteLine(Globals.SphereColor.ToArgb());
            sw.WriteLine(Globals.WorldColor.ToArgb());
            sw.WriteLine(comboBox1.SelectedIndex.ToString());
            sw.Close();
            MessageBox.Show("Done!", "Settings");
        }

        private void Settings_SizeChanged(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Normal;
        }

        private void btnShared_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Shared (shared.map)|shared.map";
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                txtShared.Text = ofd.FileName;
            }
        }

        private void btnMainMenu_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Main Menu (mainmenu.map)|mainmenu.map";
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                txtMainMenu.Text = ofd.FileName;
            }
        }

        private void btnSingleplayerShared_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Singleplayer Shares (single_player_shared.map)|single_player_shared.map";
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                txtSingleplayershared.Text = ofd.FileName;
            }
        }

        private void btnSphereColor_Click(object sender, EventArgs e)
        {
            ColorDialog cd = new ColorDialog();
            if (cd.ShowDialog() == DialogResult.OK)
            {
                Globals.SphereColor = cd.Color;
                btnSphereColor.BackColor = cd.Color;
            }
        }

        private void btnWorldColor_Click(object sender, EventArgs e)
        {
            ColorDialog cd = new ColorDialog();
            if (cd.ShowDialog() == DialogResult.OK)
            {
                Globals.SphereColor = cd.Color;
                btnWorldColor.BackColor = cd.Color;
            }
        }
    }
}
