﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Gravemind
{
    public partial class Updater : Form
    {
        Update Update;

        public Updater()
        {
            InitializeComponent();
            Update = new Update();
        }

        private void Updater_Load(object sender, EventArgs e)
        {
            this.Show();
            Update_Update();
        }

        public void Update_Update()
        {
            //Intialize
            Update.DownloadComplete += DownloadCompleted;
            Update.DownloadProgress += DownloadProgressChanged;

            //Download Update
            label1.Text = "Downloading...";
            Application.DoEvents();
            Update.DownloadUpdate();
        }

        private void DownloadProgressChanged(object sender, System.Net.DownloadProgressChangedEventArgs e)
        {
            //Update our progress
            progressBarX1.Value = e.ProgressPercentage;
        }

        void DownloadCompleted(object sender, AsyncCompletedEventArgs e)
        {
            //Download Complete
            Update.ByteProgression += new Xceed.FileSystem.ByteProgressionEventHandler(ByteProgression);

            //Install
            label1.Text = "Installing...";
            progressBarX1.Value = 0;
            Application.DoEvents();
            Update.InstallUpdate();

            if (MessageBox.Show("You must restart Gravemind for the update to finish.\nWould you like to restart now?", "Complete Update", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                System.Diagnostics.Process.Start(Application.StartupPath + "\\Gravemind.exe");
                Application.Exit();
            }
            else
            {
                this.Close();
            }
        }

        void ByteProgression(object sender, Xceed.FileSystem.ByteProgressionEventArgs e)
        {
            progressBarX1.Value = e.AllFilesBytes.Percent;
        }
    }
}
