﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HaloMap.BSP;

namespace HaloMap
{
    public class LightmapGroup
    {
        public List<Clustor> Clustors = new List<Clustor>();
        public List<PoopDefinition> PoopDefintions = new List<PoopDefinition>();
        public List<GeometryBucket> GeometryBuckets = new List<GeometryBucket>();
    }
    public class Clustor
    {
        public int RawPointerOffset, RawOffset, RawSize, RawHeaderSize, RawWithoutHeader;
        public List<Resource> Resources = new List<Resource>();
    }
    public class PoopDefinition
    {
        public int RawPointerOffset, RawOffset, RawSize, RawHeaderSize, RawWithoutHeader;
        public List<Resource> Resources = new List<Resource>();
    }
    public class GeometryBucket
    {
        public int RawPointerOffset, RawOffset, RawSize, RawHeaderSize, RawWithoutHeader;
        public List<Resource> Resources = new List<Resource>();
    }

    public class Lightmap
    {
        public Tag Tag;

        public List<LightmapGroup> Groups = new List<LightmapGroup>();

        public void Read(Map map, Tag Tag)
        {
            this.Tag = Tag;

            //Lightmap Groups
            map.br.BaseStream.Position = Tag.MetaOffset + 128;
            Reflexive r = new Reflexive();
            r.Read(map, true);
            for (int i = 0; i < r.ChunkCount; i++)
            {
                //Clustors
                LightmapGroup Group = new LightmapGroup();
                map.br.BaseStream.Position = r.Translation + (104 * i) + 32;
                Reflexive c = new Reflexive();
                c.Read(map, true);
                for (int x = 0; x < c.ChunkCount; x++)
                {
                    Clustor Clustor = new Clustor();
                    map.br.BaseStream.Position = c.Translation + (84 * i) + 40;
                    Clustor.RawPointerOffset = (int)map.br.BaseStream.Position;
                    Clustor.RawOffset = map.br.ReadInt32();
                    Clustor.RawSize = map.br.ReadInt32();
                    Clustor.RawHeaderSize = map.br.ReadInt32();
                    Clustor.RawWithoutHeader = map.br.ReadInt32();
                    Reflexive Resource = new Reflexive();
                    Resource.Read(map, true);
                    for (int z = 0; z < Resource.ChunkCount; z++)
                    {
                        Resource Res = new Resource();
                        map.br.BaseStream.Position = Resource.Translation + (16 * i) + 4;
                        Res.PrimaryLocator = map.br.ReadInt16();
                        Res.ChunkSize = map.br.ReadInt16();
                        Res.Size = map.br.ReadInt32();
                        Res.Offset = map.br.ReadInt32();
                        Clustor.Resources.Add(Res);
                    }
                    Group.Clustors.Add(Clustor);
                }

                //Poop Definitions
                map.br.BaseStream.Position = r.Translation + (104 * i) + 48;
                Reflexive p = new Reflexive();
                p.Read(map, true);
                for (int x = 0; x < p.ChunkCount; x++)
                {
                    PoopDefinition Poop = new PoopDefinition();
                    map.br.BaseStream.Position = p.Translation + (84 * i) + 40;
                    Poop.RawPointerOffset = (int)map.br.BaseStream.Position;
                    Poop.RawOffset = map.br.ReadInt32();
                    Poop.RawSize = map.br.ReadInt32();
                    Poop.RawHeaderSize = map.br.ReadInt32();
                    Poop.RawWithoutHeader = map.br.ReadInt32();
                    Reflexive Resource = new Reflexive();
                    Resource.Read(map, true);
                    for (int z = 0; z < Resource.ChunkCount; z++)
                    {
                        Resource Res = new Resource();
                        map.br.BaseStream.Position = Resource.Translation + (16 * i) + 4;
                        Res.PrimaryLocator = map.br.ReadInt16();
                        Res.ChunkSize = map.br.ReadInt16();
                        Res.Size = map.br.ReadInt32();
                        Res.Offset = map.br.ReadInt32();
                        Poop.Resources.Add(Res);
                    }
                    Group.PoopDefintions.Add(Poop);
                }

                //GeometryBuckets
                map.br.BaseStream.Position = r.Translation + (104 * i) + 64;
                Reflexive b = new Reflexive();
                b.Read(map, true);
                for (int x = 0; x < b.ChunkCount; x++)
                {
                    GeometryBucket Bucket = new GeometryBucket();
                    map.br.BaseStream.Position = b.Translation + (56 * i) + 12;
                    Bucket.RawPointerOffset = (int)map.br.BaseStream.Position;
                    Bucket.RawOffset = map.br.ReadInt32();
                    Bucket.RawSize = map.br.ReadInt32();
                    Bucket.RawHeaderSize = map.br.ReadInt32();
                    Bucket.RawWithoutHeader = map.br.ReadInt32();
                    Reflexive Resource = new Reflexive();
                    Resource.Read(map, true);
                    for (int z = 0; z < Resource.ChunkCount; z++)
                    {
                        Resource Res = new Resource();
                        map.br.BaseStream.Position = Resource.Translation + (16 * i) + 4;
                        Res.PrimaryLocator = map.br.ReadInt16();
                        Res.ChunkSize = map.br.ReadInt16();
                        Res.Size = map.br.ReadInt32();
                        Res.Offset = map.br.ReadInt32();
                        Bucket.Resources.Add(Res);
                    }
                    Group.GeometryBuckets.Add(Bucket);
                }
                Groups.Add(Group);
            }
        }
    }
}
