﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace HaloMap
{
    public partial class Enum : UserControl
    {
        public Type t;
        public List<string> Items;
        public List<int> Values;
        public int Offset;
        public object Index;
        public string Description;

        public Enum(Type t, int Offset, string Description, List<string> Items, List<int> Values, object Index)
        {
            InitializeComponent();
            this.t = t;
            this.Offset = Offset;
            this.Description = Description;
            this.Items = Items;
            this.Index = Index;
            this.Values = Values;
        }

        private void Enum_Load(object sender, EventArgs e)
        {
            label1.Text = Description;
            foreach (string s in Items)
            {
                comboBox1.Items.Add(s);
            }
            string Val = Index.ToString();
            for (int i = 0; i < Values.Count; i++)
            {
                if (Values[i] == Convert.ToInt32(Val))
                    try { comboBox1.Text = Items[i]; return; }
                    catch { }
                else
                    comboBox1.SelectedText = "";
            }
        }

        public void Update(object Value)
        {
            comboBox1.SelectedText = "";
            comboBox1.Text = "";
            string Val = Value.ToString();
            for (int i = 0; i < Values.Count; i++)
            {
                if (Values[i] == Convert.ToInt32(Val))
                    try { comboBox1.Text = Items[i]; return; }
                    catch { }
                else
                    comboBox1.SelectedText = "";
            }
        }

        public object Save()
        {
            Index = comboBox1.SelectedIndex;
            try { return Values[(int)Index]; }
            catch { return -1; }
        }

        public void Poke(ProcessStream p, int Translation)
        {
            if (t == typeof(byte))
            {
                Index = p.ReadByte(Offset - Translation);
            }
            else if (t == typeof(short))
            {
                Index = p.ReadInt16(Offset - Translation);
            }
            else if (t == typeof(int))
            {
                Index = p.ReadInt32(Offset - Translation);
            }
            Update(Index);
        }
    }
}
