﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.VisualBasic;

namespace HaloMap
{
    public partial class Ident : UserControl
    {
        public string Description;
        public TagReference Tag;
        public Map map;
        bool Loaded = false;
        bool Loaded2 = false;
        public int Offset;

        public Ident(TagReference Tag, Map map, string Description)
        {
            InitializeComponent();
            this.Tag = Tag;
            this.map = map;
            this.Description = Description;
            this.Offset = Tag.Offset;
        }

        private void Ident_Load(object sender, EventArgs e)
        {
            label1.Text = Description;
            comboBoxEx1.Sorted = true;
            comboBoxEx1.Text = Tag.Class;
            comboBoxEx2.Text = Tag.Tag.Path;
        }

        private void comboBoxEx1_SelectedIndexChanged(object sender, EventArgs e)
        {
            comboBoxEx2.Items.Clear();
            Tag.Tag.Class = comboBoxEx1.SelectedItem.ToString();
            Loaded2 = false;
            comboBoxEx2.Items.Add("Null");
            comboBoxEx2.Sorted = true;
        }

        public void Update()
        {
            comboBoxEx1.Text = Tag.Class;
            comboBoxEx2.Text = Tag.Tag.Path;
        }

        public TagReference Save()
        {
            Tag.Class = comboBoxEx1.Text;
            Tag.Tag.Path = comboBoxEx2.Text;
            Tag.Tag.Identifier = map.FindIdent(Tag.Class, Tag.Tag.Path);
            Tag.Offset = Offset;
            return Tag;
        }

        private void comboBoxEx1_DropDown(object sender, EventArgs e)
        {
            if (Loaded == false)
            {
                foreach (Tag t in map.Tags)
                {
                    if (comboBoxEx1.Items.Contains(t.Class) == false)
                    {
                        comboBoxEx1.Items.Add(t.Class);
                    }
                }
                comboBoxEx1.SelectedItem = Tag.Tag.Class;
                Loaded = true;
            }
        }

        private void comboBoxEx2_DropDown(object sender, EventArgs e)
        {
            if (Loaded2 == false && comboBoxEx1.Text != "")
            {
                Tag.Tag.Class = comboBoxEx1.Text;
                foreach (Tag t in map.Tags)
                {
                    if (t.Class == Tag.Tag.Class)
                    {
                        comboBoxEx2.Items.Add(t.Path);
                    }
                }
                Loaded2 = true;
            }
        }

        public void Poke(ProcessStream p, int Translation)
        {
            string C = Strings.StrReverse(p.ReadString(Offset - Translation, 4));
            int I = p.ReadInt32(Offset - Translation + 4);
            Tag.Class = C;
            Tag.Ident = I;
            Tag.Tag = map.FindTag(I);
            Update();
        }
    }
}
