﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace HaloMap
{
    public partial class Slot : UserControl
    {
        public List<MapSlot> SPMaps = new List<MapSlot>();
        public List<MapSlot> MPMaps = new List<MapSlot>();
        public Map map;

        public Slot(Map map, List<MapSlot> SP, List<MapSlot> MP)
        {
            InitializeComponent();
            this.SPMaps = SP;
            this.MPMaps = MP;
            this.map = map;
        }

        private void Slot_Load(object sender, EventArgs e)
        {
            LoadSP();
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int Index = listView1.FocusedItem.Index;
            if (radioButton2.Checked == true)
            {
                //Campaign
                pictureBox2.Image = SPMaps[Index].Preview;
                txtCampaignId.Text = SPMaps[Index].CampaignId.ToString();
                txtMapId.Text = SPMaps[Index].MapId.ToString();
                txtName.Text = SPMaps[Index].Name[0];
                txtDescription.Text = SPMaps[Index].Description[0];
            }
            else if (radioButton1.Checked == true)
            {
                //Multiplayer
                pictureBox2.Image = MPMaps[Index].Preview;
                txtCampaignId.Text = MPMaps[Index].CampaignId.ToString();
                txtMapId.Text = MPMaps[Index].MapId.ToString();
                txtName.Text = MPMaps[Index].Name[0];
                txtDescription.Text = MPMaps[Index].Description[0];
            }
        }

        public void LoadSP()
        {
            listView1.Items.Clear();
            ImageList Images = new ImageList();
            foreach (MapSlot ms in SPMaps)
            {
                Images.Images.Add(new System.Drawing.Bitmap(ms.Preview));
            }
            listView1.LargeImageList = Images;
            for (int i = 0; i < SPMaps.Count; i++)
            {
                listView1.Items.Add(SPMaps[i].Name[0], i);
            }
        }

        public void LoadMP()
        {
            listView1.Items.Clear();
            ImageList Images = new ImageList();
            foreach (MapSlot ms in MPMaps)
            {
                Images.Images.Add(new System.Drawing.Bitmap(ms.Preview));
            }
            listView1.LargeImageList = Images;
            for (int i = 0; i < MPMaps.Count; i++)
            {
                listView1.Items.Add(MPMaps[i].Name[0], i);
            }
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            LoadSP();
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            LoadMP();
        }
    }
}
