﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace HaloMap
{
    public class Misc
    {
        public static byte[] BitArrayToByteArray(BitArray bits)
        {
            // Who knows, might change
            const int BITSPERBYTE = 8;

            // Get the size of bytes needed to store all bytes
            int bytesize = bits.Length / BITSPERBYTE;
            // Any bit left over another byte is necessary
            if (bits.Length % BITSPERBYTE > 0)
            {
                bytesize++;
            }

            // For the result
            byte[] bytes = new byte[bytesize];

            // Must init to good value, all zero bit byte has value zero
            // Lowest significant bit has a place value of 1, each position to
            // to the left doubles the value
            byte value = 0;
            byte significance = 1;

            // Remember where in the input/output arrays
            int bytepos = 0;
            int bitpos = 0;

            while (bitpos < bits.Length)
            {
                // If the bit is set add its value to the byte
                if (true == bits[bitpos])
                {
                    value += significance;
                }
                bitpos++;
                if (0 == bitpos % BITSPERBYTE)
                {
                    // A full byte has been processed, store it
                    // increase output buffer index and reset work values
                    bytes[bytepos] = value;
                    bytepos++;
                    value = 0;
                    significance = 1;
                }
                else
                {
                    // Another bit processed, next has doubled value
                    significance *= 2;
                }
            }
            return bytes;
        }

        public static byte[] ConvertDecimalToByteArray(decimal src)
        {
            using(MemoryStream stream = new MemoryStream())
            {
                using(BinaryWriter writer = new BinaryWriter(stream))
                {
                    writer.Write(src);
                    return stream.ToArray();
                }
            }
        }

    }
}
